#include <bits/stdc++.h>
using namespace std;

using ull = __int128;

pair<ull, long long> ans;
vector<int> primes;
vector<int> limits;

int ops = 0;

ull toInt128(const string& s) {
    ull ans = 0;
    for (char c: s) {
        ans = 10*ans+c-'0';
    }
    return ans;
}

ull readInt128() {
    string s; cin >> s;
    return toInt128(s);
}

void print(ull x) {
    string s;
    while (x) {
        s.push_back(x%10+'0');
        x /= 10;
    }
    reverse(s.begin(), s.end());
    if (s.empty()) s = "0";
    cout << s;
}

bool isPrime(int n) {
    if (n <= 1) return false;
    for (int i = 2; i*i <= n; i++) {
        if (n%i == 0) return false;
    }
    return true;
}

void bf(int n, int k, vector<int>& v, ull y, ull prod, long long divs) {
    ops++;
    if (v.size() > primes.size()) return;
    if (n < 0) return;
    if (n == 0) {
        if (divs > ans.second) {
            ans = {prod, divs};
        }
        return;
    }

    int maximum = min(k, limits[v.size()]);
    if (v.size()) maximum = min(maximum, v.back());

    for (int i = 1; i <= maximum; i++) {
        if (primes[v.size()] > y/prod) break;
        prod *= primes[v.size()];

        v.push_back(i);
        bf(n-i, i, v, y, prod, divs*(i+1));
        v.pop_back();
    }
}

int main() {
    ull x = readInt128();
    ull y = readInt128();

    ans = {1, 1};
    for (int i = 1; i <= y/ans.first; i++) {
        if (!isPrime(i)) continue;
        primes.push_back(i);
        ans = {i*ans.first, 2*ans.second};
    }

    int nextPrime = primes.back()+1;
    while (!isPrime(nextPrime)) nextPrime++;

    int maxLimit = 0;
    for (int i = 0; i < primes.size(); i++) {
        int product = 1;
        int cnt = 0;
        while (product <= nextPrime) {
            product *= primes[i];
            cnt++;
        }
        cout << i << " " << " " << nextPrime << " " << cnt << endl;
        limits.push_back(2*cnt-2);
        maxLimit+=limits.back();
    }

    vector<int> v;
    for (int i = 1; i <= maxLimit; i++) {
        bf(i, i, v, y, 1, 1);
        //cout << i << " " << ops << endl;
    }

    print(ans.first);
    cout << endl;
    cout << ans.second << endl;

    return 0;
}
