#include <bits/stdc++.h>
using namespace std;

using ull = __int128;

pair<ull, long long> ans;
vector<int> primes;

int ops = 0;

void print(__int128 x) {
    string s;
    while (x) {
        s.push_back(x%10+'0');
        x /= 10;
    }
    reverse(s.begin(), s.end());
    cout << s;
}

bool isPrime(int n) {
    if (n <= 1) return false;
    for (int i = 2; i*i <= n; i++) {
        if (n%i == 0) return false;
    }
    return true;
}

void bf(int n, int k, vector<int>& v, ull b, ull prod, long long divs) {
    ops++;
    if (v.size() > primes.size()) return;
    if (n < 0) return;
    if (n == 0) {
        if (divs == ans.second && prod < ans.first) {
            ans = {prod, divs};
        }
        if (divs > ans.second) {
            ans = {prod, divs};
        }
        return;
    }

    //if (divs*(1<<n) <= ans.second) return;

    int maximum = k;
    if (v.size()) maximum = v.back();

    for (int i = 1; i <= maximum; i++) {
        if (primes[v.size()] > b/prod) break;
        prod *= primes[v.size()];

        v.push_back(i);
        bf(n-i, i, v, b, prod, divs*(i+1));
        v.pop_back();
    }
}

pair<ull, long long> solve(ull b) {
    ans = {1, 1};

    primes.clear();
    for (int i = 1; i <= b/ans.first; i++) {
        if (!isPrime(i)) continue;
        primes.push_back(i);
        ans = {i*ans.first, 2*ans.second};
    }

    vector<int> v;
    for (int i = 1; i <= 40; i++) {
        bf(i, i, v, b, 1, 1);
    }
    return ans;
}

int main() {
    ull n = 1e41-;

    vector<pair<ull, long long>> v;
    for (int i = 1; n; i++) {
        solve(n);
        print(ans.first);
        cout << " " << ans.second << endl;
        v.push_back(ans);
        n = ans.first-1;
    }

    reverse(v.begin(), v.end());
    int last = 0;
    for (auto p: v) {
        if (p.second == last) continue;

        print(p.first);
        cout << ",";
        last = p.second;
    }
    cout << endl;
    cout << v.size() << endl;


    return 0;
}
