#include<iostream>
#include<vector>
#include<map>
using namespace std;
vector <int> primes;
long long int n;
vector <map <int, long long int> > best;
pair <int, long long int> rec (int ind, long long int prod, int divs) {
    if (ind==primes.size()) return {divs, prod};
    auto it=best[ind].lower_bound(divs);
    if ((it!=best[ind].end())&&(it->second<=prod)) return {divs, prod};
    auto [curr, ignore]=best[ind].insert({divs, prod});
    for (;;) {
        if (curr==best[ind].begin()) break;
        auto tmp=curr;
        tmp--;
        if (tmp->second<prod) break;
        best[ind].erase(tmp);
    }
    int p=primes[ind];
    pair <int, long long int> ans={divs, prod};
    for (int pow=1; ; pow++) {
        if (n/prod<p) break;
        prod*=p;
        ans=max(ans,rec(ind+1,prod,divs*(pow+1)));
    }
    return ans;
}
int main () {
    cin >> n >> n ;
    long long int prod=1;
    for (int i=2; ; i++) {
        if (n/prod<i) break;
        bool flag=true;
        for (int j=2; j<i; j++) {
            if (i%j==0) {
                flag=false;
                break;
            }
        }
        if (flag==true) {
            primes.push_back(i);
            prod*=i;
        }
    }
    best.resize(primes.size());
    cout << rec(0,1,1).second ;
    cout << endl ;
    return 0;
}
