#include<bits/stdc++.h>
using namespace std;

vector<int> primes;

bool isPrime(int n) {
    if (n < 2) return false;
    for (int i = 2; i*i <= n; i++) {
        if (n%i == 0) return false;
    }
    return true;
}

void calcPrimes(long long n) {
    long long prod = 1;
    for (int i = 1; i <= 1000; i++) {
        if (prod > n) break;
        if (!isPrime(i)) continue;
        primes.push_back(i);
        prod*=i;
    }
}

int divs(long long n) {
    int ans = 1;
    for (int i = 0; i < primes.size(); i++) {
        if (n == 1) break;
        if (n%primes[i] != 0) return 0;
        int curr = 0;
        while (n%primes[i] == 0) {
            curr++;
            n/=primes[i];
        }
        ans*=curr+1;
    }
    return ans;
}

int main() {
    int x, y; cin >> x >> y;

    calcPrimes(y);

    long long ans = 1;
    int divsAns = 1;
    for (int i = x; i <= y; i++) {
        int divsI = divs(i);
        if (divsI > divsAns) {
            ans = i;
            divsAns = divsI;
        }
    }
    cout << ans << endl;

    return 0;
}
